<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head><meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
  <title>pyxmpp</title>
  <link rel="stylesheet" href="style.css" type="text/css" />
</head>
<body>
  <div id="title">
    <h1>PyXMPP</h1>
    <p id="subtitle">A Python Jabber/XMPP implementation.</p>
  </div>
  <div id="navblock">
    <div id="navbar">
      <p class="linkhead">about</p>
      <p class="link"><a href="index.html#introduction">introduction</a></p>
      <p class="link"><a href="https://github.com/Jajcus/pyxmpp">GitHub project page</a></p>
      <p class="link"><a href="http://lists.jajcus.net/mailman/listinfo/pyxmpp">mailing list</a></p>
      <p class="linkhead">download</p>
      <p class="link"><a href="https://github.com/Jajcus/pyxmpp/downloads">downloads</a></p>
      <p class="linkhead">documentation</p>
      <p class="link"><a href="ChangeLog.html">ChangeLog</a></p>
      <p class="link"><a href="api/">API documentation</a></p>
      <p class="link"><a href="CHANGES.html">API changes</a></p>
      <p class="linkhead">applications</p>
      <p class="link"><a href="http://cjc.jajcus.net/" title="Console Jabber Client">CJC</a></p>
      <p class="link"><a href="http://jjigw.jajcus.net/" title="Jajcus' Jabber to IRC Gateway">JJIGW</a></p>
      <p class="link"><a href="http://vcjb.berlios.de/" title="Version Control Jabber roBot">VCJB</a></p>
      <p class="link"><a href="http://bluszcz.jabberpl.org/pyrss/" title="Python based RSS's notifier for Jabber">PyRSS</a></p>
      <p class="linkhead">similar projects</p>
      <p class="link"><a href="http://xmpppy.sourceforge.net/" title="The jabber python project">Xmpppy</a></p>
      <p class="link"><a href="http://www.twistedmatrix.com/" title="An event-driven networking framework including Jabber support">Twisted</a></p>
      <p class="link"><a href="http://jabberpy.sourceforge.net/" title="A Python Jabber library">jabber.py</a></p>
    </div>
  </div>
  <div id="mainblock">
    <div id="main">
    <div class="section" id="most-important-api-changes">
<h2>Most Important API Changes</h2>
<p>Those are mentioned here as are not backward compatible.
I want the API to be stable and consistent in the next release and later,
so I do all the big changes now (I would have to do them at some time anyway).</p>
<p>2010-04-03</p>
<blockquote>
<p>M2Crypto dependency dropped in favor of the 'ssl' module from the
standard Python library. TLS API has been changed a bit: certificate
verification callback now should expect one argument only (a dictionary
with certificate information)</p>
<p>Python 2.6 is now _required!</p>
</blockquote>
<p>2006-08-31</p>
<blockquote>
<p>Interface API for better externalisation of various components. First
introduced to the Client classes -- one may create different classes
to handle different stanza types and namespaces, annotate them with
interfaces implemented (IFeaturesProvider, IPresenceHandlersProvider,
IMessageHandlersProvider or IIqHandlersProvider) and list their
instances in a Client object's interface_providers attribute.</p>
<p>See the echocomponent.py example to see how to use that.</p>
</blockquote>
<p>2006-08-26</p>
<blockquote>
<p>Exception handling improvements, part one.</p>
<p>All PyXMPP-specific exceptions moved to pyxmpp.exceptions module. Some exceptions
have been removed (those which were used where some standard exception, like ValueError,
would be a better choice), the most important omission is StanzaError exception.</p>
<p>ProtocolError exception with some derivatives added -- these are raised when
an error is detected in a stanza (received) processed. These exceptions
will be handled internally by PyXMPP some day (automatically
&lt;bad-request/&gt; or similar XMPP error will be raised).</p>
</blockquote>
<p>2006-08-26</p>
<blockquote>
CachedPropertyObject class removed and its usage in pyxmpp.jabber.disco
Now all the DiscoItem/DiscoInfo/DiscoItems attributes are regular properties
calling set_*, get_* funtions on every access.
The old cached properties were giving no speed gain and only complicated things.</blockquote>
<p>2005-10-14</p>
<blockquote>
Usage of non-unicode strings in PyXMPP API is deprecated. No
no implicit conversion is made where utf-8 string would previously be
accepted (e.g. JID constructor). Sometimes deprecation warning will be
raised when string is used instead of unicode.</blockquote>
<p>2005-03-20</p>
<blockquote>
"common_doc", "common_root", and "common_ns" can no longer be imported
from the "stanza" module. They were moved to the "xmlextra" module.</blockquote>
<p>2005-01-20</p>
<blockquote>
Minor change: now "disco_info" and "disco_items" attributes
of pyxmpp.jabber.client and pyxmpp.jabberd.component are initialized
in the constructors of those classes. Those __init__() methods now
accept "disco_name", "disco_category" and "disco_type" arguments
to set up the entity identity. Also register_feature() and
unregister_feature() methods were added for managing the feature
list in .disco_info.</blockquote>
<p>2005-01-09</p>
<blockquote>
<p>Continuation of the big API unification.</p>
<p>All attribute and parameter names "node", relating to XML node have
been renamed to "xmlnode". The most important change is <cite>Stanza.node</cite> renamed
to <cite>Stanza.xmlnode</cite>.</p>
<p>Roster.items(), Roster.groups(), Roster.items_by_name(), Roster.items_by_group(),
Roser.items_by_jid() renamed to: Roster.get_items(), Roster.get_groups(),
Roster.get_items_by_name(), Roster.get_items_by_group(), Roster.get_item_by_jid()</p>
<p>Keys of Roster.items_dict are now JIDs, not unicode.</p>
<p>More .as_xml() methods unified. To reuse most of the code needed two
new virtual classes were added: pyxmpp.objects.StanzaPayloadObject
and pyxmpp.objects.StanzaPayloadWrapperObject. Objects providing .as_xml()
methods may be used directly as argument to Stanza.set_content() and
Stanza.add_content() methods.</p>
</blockquote>
<p>2005-01-06</p>
<blockquote>
<p>Big API unification started.</p>
<p>jabber.vcard.VCard and jabber.delay.Delay
classes' method as_xml accepts now "parent" and "doc" arguments in
that order. Argument interpretation is also unified. All other similar
objects will have the add_xml() with the same signature soon.</p>
<p>Classes in jabber.disco module were modified heavily, so  all the
getter are named get_*, all the setters set_* and all the interesting
properties may be accessed as attributes which also adds some caching.
Other classes, if they don't use that get_*/set_* naming, will be
modified in similar way soon.</p>
</blockquote>
<p>2004-12-31</p>
<blockquote>
<p>There was a design flaw in PyXMPP from the very beginning, which caused
that many unnecessary modules from PyXMPP package (and subpackages,
when they were used) were imported even when only one simple module was
used. That was because pyxmpp imported all the useful names from
submodules. That was a problem (unnecessarily long startup time
sometimes), but it was also quite convenient.</p>
<p>To resolve the problem those imports were removed from __init__
modules, so importing a package doesn't cause any other imports now.
To improve backward compatibility and keep the convenience of the old
behavior "all" modules were added to "pyxmpp", "pyxmpp.jabber" and
"pyxmpp.jabber" packages.</p>
<p>If your application was broken by that change just import "pyxmpp.all"
(and/or "pyxmpp.jabber.all", "pyxmpp.jabberd.all" if you use them)
there -- you need to do it once per application (no need to change
every module). After that everything should work as before.</p>
<p>If you use only small part of the API and don't want to import unused
modules import names like "JID" or "Stanza" directly from modules that
define them (e.g.: 'import JID from pyxmpp.jid').</p>
</blockquote>
<p>2004-12-18</p>
<blockquote>
dnspython (<a class="reference external" href="http://www.dnspython.org">http://www.dnspython.org</a>) is now used for resolving DNS
names. Please note, that because of a conflict between dnspython and
old PyXMPP DNS implementation you must clean up after old PyXMPP
installation and do 'make clean' before building PyXMPP.</blockquote>
<p>2004-09-16</p>
<blockquote>
<p>Stanza, Message, Iq and Presence constructors arguments have been
changed again. "typ" and "sid" were really stupid and ugly.
Now Stanza (derived classes) constructor keyword parameters are:
from_jid, to_jid, stanza_type, stanza_id</p>
<p>I hope this will never change again, at least not after the next
official release. You may update your application code using
"migrate-0_5-0_6.py" script.</p>
</blockquote>
<p>2004-09-13</p>
<blockquote>
Stanza, Message, Iq and Presence constructors arguments have been
changed so build-ins "type" and "id" are not redefined. So the "type"
argument has been changed to "typ" and the "id" argument to "sid"
(stanza id).</blockquote>
<p>2004-09-03</p>
<blockquote>
Stream.data_in and Stream.data_out callbacks removed. Data sent and
received is now logged via 'logging' module to 'pyxmpp.Stream.out' and
'pyxmpp.Stream.in' loggers.  The raw data is available for logging
handlers as the first element of 'args' attribute of the log record
(record.args[0]).</blockquote>
<p>2004-08-29</p>
<blockquote>
All debug messages are passed to the standard python 'logging' module.
There is no debug() methods in PyXMPP classes any more.</blockquote>
<p>2005-06-02</p>
<blockquote>
Python 2.2 support is gone. Compliant XMPP implementation
requires stringprep and IDN support. Python 2.3 provides both,
Python 2.2 none. Maintaining separete stringprep and IDN
implementations for use with Python 2.2 is IMHO not worth the effort
needed.</blockquote>
<p>2005-05-28</p>
<blockquote>
<blockquote>
<p>Roster and RosterItems classes rewritten. Now they are not wrapper
around roster XML node any more. Old code was complicated, slow,
and not standard compliant (ingored stringprep profiles).</p>
<p>Most important changes:</p>
<ul class="simple">
<li>no <cite>node</cite> attribute in Roster and RosterItem</li>
<li>RosterItem constructor doesn't take <cite>roster</cite> argument any more</li>
<li><cite>jid</cite>, <cite>ask</cite>, <cite>subscription</cite>, <cite>name</cite> and <cite>groups</cite> are now attributes,
not methods, of <cite>RosterItem</cite></li>
<li><cite>add_group</cite>, <cite>rm_group</cite>, etc. methods of <cite>RosterItem</cite> are gone. Use
list operations on <cite>groups</cite> attribute now.</li>
<li>inline documentation included</li>
</ul>
</blockquote>
<p>vi: spell spelllang=en</p>
</blockquote>
</div></div>
  </div>
</body>
</html>
<!-- vi: set encoding=utf-8 :-->
